package com.kupal.commons.cdm;

/**
 * Represents domain objects need to be persisted.
 *
 * @author Kupal
 *         Date: 28.06.2010
 *         Time: 16:43:35
 */
public interface Persistence extends Domain {

    /**
	 * Gets the unique identifier for this domain object.
	 * @return the unique identifier.
	 */
	Long getId();

	/**
	 * Sets the unique identifier for this domain model object.
	 * @param id the new unique identifier.
	 */
	void setId(final Long id);

	/**
	 * <code>true</code> if the object has previously been persisted.
	 * <p>
	 * @return <code>true</code> if the object has previously been persisted.
	 */
	boolean isPersistent();

    /**
     * Interceptor to perform tasks before persisting changes.
     */
    void executeBeforePersistAction();
}